> ## Documentation Index
> Fetch the complete documentation index at: https://docs.voucherify.io/llms.txt
> Use this file to discover all available pages before exploring further.

# List Products

> Retrieve a list of products.



## OpenAPI

````yaml /openapi/products.json get /v1/products
openapi: 3.0.1
info:
  title: Voucherify API - Products
  version: v2018-08-01
  description: >-
    Voucherify promotion engine REST API. Please see
    https://docs.voucherify.io/docs for more details.
  contact:
    name: Voucherify Team
    url: https://www.voucherify.io/contact-support
    email: support@voucherify.io
  termsOfService: https://www.voucherify.io/legal/subscription-agreement
  license:
    name: MIT
    url: https://github.com/voucherifyio/voucherify-js-sdk/blob/main/LICENSE
servers:
  - url: https://{cluster}.voucherify.io
    description: Base URL
    variables:
      cluster:
        default: api
        enum:
          - api
          - us1.api
          - as1.api
          - download
          - us1.download
          - as1.download
security: []
paths:
  /v1/products:
    get:
      tags:
        - Products
      summary: List Products
      description: Retrieve a list of products.
      operationId: list-products
      parameters:
        - $ref: '#/components/parameters/limit'
        - $ref: '#/components/parameters/page'
        - $ref: '#/components/parameters/order'
        - $ref: '#/components/parameters/start_date'
        - $ref: '#/components/parameters/end_date'
      responses:
        '200':
          description: >-
            Returns a dictionary with product objects. The products are returned
            sorted by creation date by default, with the most recent products
            appearing last, unless you specify another sequence using the
            `order` query parameter.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProductsListResponseBody'
              examples:
                Example:
                  value:
                    object: list
                    data_ref: products
                    products:
                      - id: prod_f1r5Tpr0DuC7
                        source_id: test_prod_id_1
                        name: Apple iPhone 8
                        price: null
                        attributes:
                          - color
                          - memory
                        metadata:
                          test: true
                          vendor: Cortland
                        image_url: null
                        created_at: '2021-12-03T06:33:46.101Z'
                        updated_at: null
                        object: product
                        skus:
                          data:
                            - id: sku_0a417bd1d9952f9d6f
                              source_id: test_iphone_8_silver_256gb
                              product_id: prod_f1r5Tpr0DuC7
                              sku: iPhone 8 Silver 256GB
                              price: null
                              currency: null
                              attributes:
                                color: silver
                                memory: '256'
                              image_url: null
                              metadata: {}
                              created_at: '2021-12-03T06:33:46.599097+00:00'
                              updated_at: null
                              object: sku
                            - id: sku_0a417bd1d9952f9d6e
                              source_id: test_iphone_8_silver_64gb
                              product_id: prod_f1r5Tpr0DuC7
                              sku: iPhone 8 Silver 64GB
                              price: null
                              currency: null
                              attributes:
                                color: silver
                                memory: '64'
                              image_url: null
                              metadata: {}
                              created_at: '2021-12-03T06:33:46.598595+00:00'
                              updated_at: null
                              object: sku
                          total: 2
                      - id: prod_0ac67e1bb8072eec48
                        source_id: test_volleyball
                        name: VolleyBall
                        price: 1100
                        attributes: []
                        metadata:
                          color:
                            - white
                          label: true
                          origin: PL
                        image_url: null
                        created_at: '2022-03-16T14:01:45.459Z'
                        updated_at: '2022-04-26T12:51:35.500Z'
                        object: product
                        skus:
                          data:
                            - id: sku_0ac768973f5c4ea0d0
                              source_id: test_volleyball_pl
                              product_id: prod_0ac67e1bb8072eec48
                              sku: PL
                              price: 500
                              currency: USD
                              attributes: {}
                              image_url: null
                              metadata:
                                color:
                                  - red
                              created_at: '2022-03-17T07:06:13.629918+00:00'
                              updated_at: null
                              object: sku
                            - id: sku_0ac7689713072e1df6
                              source_id: test_volleyball_us
                              product_id: prod_0ac67e1bb8072eec48
                              sku: US
                              price: 1500
                              currency: USD
                              attributes: {}
                              image_url: null
                              metadata:
                                color:
                                  - yellow
                              created_at: '2022-03-17T07:06:13.452532+00:00'
                              updated_at: null
                              object: sku
                          total: 2
                    total: 2
      security:
        - X-App-Id: []
          X-App-Token: []
        - X-Voucherify-OAuth:
            - api
            - products
components:
  parameters:
    limit:
      name: limit
      in: query
      required: false
      schema:
        $ref: '#/components/schemas/ParameterLimit'
      description: >-
        Limits the number of objects to be returned. The limit can range between
        1 and 100 items. If no limit is set, it returns 10 items.
    page:
      name: page
      in: query
      required: false
      schema:
        $ref: '#/components/schemas/ParameterPage'
      description: Which page of results to return. The lowest value is `1`.
    order:
      name: order
      in: query
      required: false
      schema:
        $ref: '#/components/schemas/ParameterOrder'
      description: >-
        Sorts the results using one of the filtering options, where the dash `-`
        preceding a sorting option means sorting in a descending order.
    start_date:
      name: start_date
      in: query
      schema:
        $ref: '#/components/schemas/ParameterDate'
      description: >-
        Timestamp representing the date and time which results must end on.
        Represented in ISO 8601 format.
    end_date:
      name: end_date
      in: query
      schema:
        $ref: '#/components/schemas/ParameterDate'
      description: >-
        Timestamp representing the date and time which results must end on.
        Represented in ISO 8601 format.
  schemas:
    ProductsListResponseBody:
      type: object
      title: Products List Response Body
      description: Response body schema for **GET** `v1/products`.
      properties:
        object:
          type: string
          description: >-
            The type of the object represented by JSON. This object stores
            information about products in a dictionary.
          default: list
        data_ref:
          type: string
          description: >-
            Identifies the name of the attribute that contains the array of
            product objects.
          default: products
        products:
          type: array
          description: Contains array of product objects.
          items:
            $ref: '#/components/schemas/Product'
        total:
          type: integer
          description: Total number of product objects.
      required:
        - object
        - data_ref
        - products
        - total
    ParameterLimit:
      type: integer
      minimum: 1
      maximum: 100
    ParameterPage:
      type: integer
      minimum: 1
      maximum: 100
    ParameterOrder:
      type: string
      enum:
        - created_at
        - '-created_at'
        - updated_at
        - '-updated_at'
        - type
        - '-type'
        - code
        - '-code'
        - campaign
        - '-campaign'
        - category
        - '-category'
    ParameterDate:
      type: string
      example: '2023-12-22T10:13:06.487Z'
      format: date-time
    Product:
      type: object
      description: >-
        This is an object representing a product.  


        This entity should be used to map product items from your inventory
        management system. The aim of products is to build which reflect
        product-specific campaigns.
      title: Product
      allOf:
        - $ref: '#/components/schemas/ProductWithoutSkus'
        - type: object
          properties:
            skus:
              $ref: '#/components/schemas/SkusListForProduct'
    ProductWithoutSkus:
      title: Product without Skus Object
      properties:
        id:
          type: string
          description: Unique product ID assigned by Voucherify.
          example: prod_0b1da8105693710357
        source_id:
          type: string
          nullable: true
          example: productSourceID16
          description: Unique product source ID.
        name:
          type: string
          nullable: true
          description: Unique user-defined product name.
          example: T-shirt
        price:
          type: integer
          nullable: true
          description: >-
            Unit price. It is represented by a value multiplied by 100 to
            accurately reflect 2 decimal places, such as `$100.00` being
            expressed as `10000`.
        attributes:
          type: array
          description: >-
            A list of product attributes whose values you can customize for
            given SKUs: `["color","size","ranking"]`. Each child SKU can have a
            unique value for a given attribute.
          items:
            type: string
        metadata:
          type: object
          description: >-
            The metadata object stores all custom attributes assigned to the
            product. A set of key/value pairs that you can attach to a product
            object. It can be useful for storing additional information about
            the product in a structured format. It can be used to create product
            collections.
        image_url:
          type: string
          nullable: true
          description: >-
            The HTTPS URL pointing to the .png or .jpg file that will be used to
            render the product image.
          example: https://images.com/original.jpg
        created_at:
          type: string
          description: >-
            Timestamp representing the date and time when the product was
            created. The value is shown in the ISO 8601 format.
          example: '2022-05-23T06:52:55.008Z'
          format: date-time
        updated_at:
          type: string
          nullable: true
          description: >-
            Timestamp representing the date and time when the product was
            updated. The value is shown in the ISO 8601 format.
          example: '2022-05-23T09:24:07.405Z'
          format: date-time
        object:
          type: string
          description: >-
            The type of the object represented by JSON. This object stores
            information about the product.
          default: product
          enum:
            - product
      required:
        - id
        - source_id
        - name
        - attributes
        - metadata
        - object
        - price
    SkusListForProduct:
      type: object
      description: Contains information about child SKUs.
      title: Skus List For Product
      properties:
        object:
          type: string
          description: >-
            The type of the object represented by JSON. This object stores
            information about SKUs.
          default: list
        data_ref:
          type: string
          description: >-
            Identifies the name of the JSON property that contains the array of
            SKUs.
          default: data
        data:
          type: array
          description: A dictionary that contains an array of SKUs.
          items:
            $ref: '#/components/schemas/Sku'
        total:
          type: integer
          description: Total number of SKUs in the product.
      required:
        - object
        - data_ref
        - data
        - total
    Sku:
      title: SKU Object
      type: object
      description: This is an object representing a product SKU.
      properties:
        id:
          type: string
          example: sku_0b1621b319d248b79f
          description: >-
            A unique identifier that represents the SKU and is assigned by
            Voucherify.
        source_id:
          type: string
          nullable: true
          example: sku_source_id_4
          description: A unique SKU identifier from your inventory system.
        product_id:
          type: string
          example: prod_0b15f6b9f650c16990
          description: The parent product's unique ID.
        sku:
          type: string
          nullable: true
          example: Large Pink Shirt
          description: Unique user-defined SKU name.
        price:
          type: integer
          nullable: true
          description: >-
            Unit price. It is represented by a value multiplied by 100 to
            accurately reflect 2 decimal places, such as `$100.00` being
            expressed as `10000`.
        currency:
          type: string
          nullable: true
          description: SKU price currency.
          example: USD
        attributes:
          type: object
          description: >-
            The attributes object stores values for all custom attributes
            inherited by the SKU from the parent product. A set of key/value
            pairs that are attached to a SKU object and are unique to each SKU
            within a product family.
        image_url:
          type: string
          nullable: true
          description: >-
            The HTTPS URL pointing to the .png or .jpg file that will be used to
            render the SKU image.
        metadata:
          type: object
          description: >-
            The metadata object stores all custom attributes assigned to the
            SKU. A set of key/value pairs that you can attach to a SKU object.
            It can be useful for storing additional information about the SKU in
            a structured format. It can be used to create product collections.
        created_at:
          type: string
          example: '2022-05-17T10:36:30.187Z'
          description: >-
            Timestamp representing the date and time when the SKU was created.
            The value is shown in the ISO 8601 format.
          format: date-time
        updated_at:
          type: string
          nullable: true
          example: '2022-05-17T10:55:09.137Z'
          description: >-
            Timestamp representing the date and time when the SKU was updated.
            The value is shown in the ISO 8601 format.
          format: date-time
        object:
          type: string
          default: sku
          description: >-
            The type of the object represented by JSON. This object stores
            information about the `SKU`.
          enum:
            - sku
      required:
        - id
        - source_id
        - product_id
        - sku
        - price
        - attributes
        - metadata
        - image_url
        - created_at
        - updated_at
        - object
  securitySchemes:
    X-App-Id:
      type: apiKey
      name: X-App-Id
      in: header
    X-App-Token:
      type: apiKey
      name: X-App-Token
      in: header
    X-Voucherify-OAuth:
      type: oauth2
      flows:
        implicit:
          authorizationUrl: https://api.voucherify.io/v1/oauth/token
          scopes:
            api: Gives access to whole server-side API.
            vouchers: >-
              Gives access to all endpoints and methods starting with
              `v1/vouchers`.
            client_api: Gives access to whole client-side API.
            client_vouchers: >-
              Gives access to all endpoints and methods starting with
              `/client/v1/vouchers`.
            promotions: >-
              Gives access to all endpoints and methods starting with
              `/v1/promotions`.
            client_promotions: >-
              Gives access to all endpoints and methods starting with
              `/client/v1/promotions`
            campaigns: >-
              Gives access to all endpoints and methods starting with
              `v1/campaigns`.
            client_publish: >-
              Gives access to all endpoints and methods starting with
              `/client/v1/publish`.
            exports: >-
              Gives access to all endpoints and methods starting with
              `/v1/exports`.
            publications: >-
              Gives access to all endpoints and methods starting with
              `/v1/publications`.
            client_validate: >-
              Gives access to all endpoints and methods starting with
              `/client/v1/validate`.
            validations: >-
              Gives access to all endpoints and methods starting with
              `/v1/validations`.
            client_validations: >-
              Gives access to all endpoints and methods starting with
              `/client/v1/validations`.
            qualifications: >-
              Gives access to all endpoints and methods starting with
              `/v1/qualifications`.
            client_qualifications: >-
              Gives access to all endpoints and methods starting with
              `/client/v1/qualifications`.
            client_redeem: >-
              Gives access to all endpoints and methods starting with
              `/client/v1/redeem
            redemptions: >-
              Gives access to all endpoints and methods starting with
              `/v1/redemptions`.
            client_redemptions: >-
              Gives access to all endpoints and methods starting with
              `/client/v1/redemptions`
            customers: >-
              Gives access to all endpoints and methods starting with
              `/v1/customers`.
            client_customers: >-
              Gives access to all endpoints and methods starting with
              `/client/v1/customers`.
            orders: >-
              Gives access to all endpoints and methods starting with
              `/v1/orders`.
            products: >-
              Gives access to all endpoints and methods starting with
              `/v1/products`.
            skus: >-
              Gives access to all endpoints and methods starting with
              `/v1/SKUs`.
            validation-rules: >-
              Gives access to all endpoints and methods starting with
              `/v1/validation-rules`.
            validation-rules-assignments: >-
              Gives access to all endpoints and methods starting with
              `/v1/validation-rules-assignments
            segments: >-
              Gives access to all endpoints and methods starting with
              `/v1/segments`.
            events: >-
              Gives access to all endpoints and methods starting with
              `/v1/events`.
            client_events: >-
              Gives access to all endpoints and methods starting with
              `client/v1/events`.
            rewards: >-
              Gives access to all endpoints and methods starting with
              `/v1/rewards`.
            assets: >-
              Gives access to all endpoints and methods starting with
              `/v1/assets`.
            task-results: >-
              Gives access to all endpoints and methods starting with
              `/v1/task-results`.
            loyalties: >-
              Gives access to all endpoints and methods starting with
              `/v1/loyalties`.
            client_consents: >-
              Gives access to all endpoints and methods starting with
              `client/v1/consents`.
            consents: >-
              Gives access to all endpoints and methods starting with
              `/v1/consents`.
            async-actions: >-
              Gives access to all endpoints and methods starting with
              `/v1/async-actions`.
            product-collections: >-
              Gives access to all endpoints and methods starting with
              `/v1/product-collections`.
            categories: >-
              Gives access to all endpoints and methods starting with
              `/v1/categories`.
            metadata-schemas: >-
              Gives access to all endpoints and methods starting with
              `/v1/metadata-schemas`.
            locations: >-
              Gives access to all endpoints and methods starting with
              `/v1/locations`.
            referrals: >-
              Gives access to all endpoints and methods starting with
              `/v1/referrals`.
            trash-bin: >-
              Gives access to all endpoints and methods starting with
              `/v1/trash-bin`.
            templates: >-
              Gives access to all endpoints and methods starting with
              `/v1/templates`.

````